#include "lanhep.h"


Atom ColorLambda=0, ColorF=0, ColorD=0, ColorEps=0, ColorEpsB=0;

int is_color_eps(Atom s)
{
	if(s!=ColorEps && s!=ColorEpsB)
	{
		puts("Internal error (ceps)");
		return 0;
	}
	return s==ColorEps;
}

int is_color_d(Atom s)
{
	if(ColorD==0)
		return 0;
	return ColorD==s;
}

Term inv_color_eps(Atom s)
{
	if(s!=ColorEps && s!=ColorEpsB)
	{
		puts("Internal error (cepi)");
		return s;
	}
	
	return s==ColorEps?ColorEpsB:ColorEps;
}


int color_repres(Term ind)
	{
	Atom a1,a2;
	ind=CompoundArg1(ind);
	if(CompoundName(ind)!=A_COLOR)
		return 0;
	a1=CompoundArg1(ind);
	a2=CompoundArg2(ind);
	if(a1==a2)
		return 3;
	if(a1<a2)
		return 1;
	return 2;
	}

static int f_symm_factor(List *ll)
	{
	List gprt,l1,l2;
	int ret;
	int flag;
	ret=1;
	gprt=*ll;

/*	WriteTerm(gprt); printf("  %d \n",ret);*/
		
	if(ListLength(gprt)<2)
		{
		
		return 1;
		}
	do
		{
		flag=0;
		l1=gprt;
		l2=ListTail(l1);
		while(!is_empty_list(l2))
			{
			Atom a1, a2;
			a1=ListFirst(l1);
			a2=ListFirst(l2);
			if(IntegerValue(a1)>IntegerValue(a2))
				{
				ChangeList(l1,a2);
				ChangeList(l2,a1);
				flag=1;
				ret*=-1;
				}
			l1=l2;
			l2=ListTail(l2);
			}
		}
		while(flag);
				

	*ll=gprt;
	return ret;
	}

void color_symm_f(List pl, Term m2)
	{
	int fact=1;
	List l;
	l=CompoundArgN(m2,3);
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);
		
		if(CompoundName(t)==OPR_SPECIAL && (
				GetAtomProperty(CompoundArg1(t),A_COLOR)==A_COLOR_F ||
				GetAtomProperty(CompoundArg1(t),A_COLOR)==A_COLOR_EPS))
			{
			List ll;
			ll=ConsumeCompoundArg(t,2);
			fact*=f_symm_factor(&ll);
			SetCompoundArg(t,2,ll);
			}
		if(CompoundName(t)==OPR_SPECIAL && 
				GetAtomProperty(CompoundArg1(t),A_COLOR)==A_COLOR_D )
			{
			List ll;
			ll=ConsumeCompoundArg(t,2);
			f_symm_factor(&ll);
			SetCompoundArg(t,2,ll);
			}
		l=ListTail(l);
		}

	if(fact-1)
		{
		Term t;
		t=CompoundArg1(m2);
		SetCompoundArg(t,1,NewInteger(-IntegerValue(CompoundArg1(t))));
		}		
	
	l=CompoundArgN(m2,3);
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);	
		if(CompoundName(t)==OPR_SPECIAL && 
			(GetAtomProperty(CompoundArg1(t),A_COLOR)==A_COLOR_F||
				GetAtomProperty(CompoundArg1(t),A_COLOR)==A_COLOR_D))
			{
			List ll;
			ll=ListTail(l);
			while(!is_empty_list(ll))
				{
				Term t1;
				t1=ListFirst(ll);
				if(CompoundName(t1)==OPR_SPECIAL && 
					(GetAtomProperty(CompoundArg1(t1),A_COLOR)==A_COLOR_F
					||GetAtomProperty(CompoundArg1(t1),A_COLOR)==A_COLOR_D) &&
					IntegerValue(ListFirst(CompoundArg2(t))) >
					IntegerValue(ListFirst(CompoundArg2(t1)))    )
					{
					List tl1,tl2;
					tl1=ConsumeCompoundArg(t,2);
					tl2=ConsumeCompoundArg(t1,2);
					SetCompoundArg(t,2,tl2);
					SetCompoundArg(t1,2,tl1);
					}
				ll=ListTail(ll);
				}
			}
		l=ListTail(l);
		}
		
	l=CompoundArgN(m2,3);
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);	
		if(CompoundName(t)==OPR_SPECIAL && 
			GetAtomProperty(CompoundArg1(t),A_COLOR)==A_COLOR_EPS)
			{
			List ll;
			ll=ListTail(l);
			while(!is_empty_list(ll))
				{
				Term t1;
				t1=ListFirst(ll);
				if(CompoundName(t1)==OPR_SPECIAL && 
					GetAtomProperty(CompoundArg1(t1),A_COLOR)==A_COLOR_EPS &&
					IntegerValue(ListFirst(CompoundArg2(t))) >
					IntegerValue(ListFirst(CompoundArg2(t1)))    )
					{
					List tl1,tl2;
					tl1=ConsumeCompoundArg(t,2);
					tl2=ConsumeCompoundArg(t1,2);
					SetCompoundArg(t,2,tl2);
					SetCompoundArg(t1,2,tl1);
					}
				ll=ListTail(ll);
				}
			}
		l=ListTail(l);
		}
		
	}
	
void epsv_symm(List pl, Term m2)
	{
	int fact=1;
	List l;
	l=CompoundArgN(m2,3);
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);
		
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_EPS_V)
			{
			List ll;
			ll=ConsumeCompoundArg(t,2);
			fact*=f_symm_factor(&ll);
			SetCompoundArg(t,2,ll);
			}
		l=ListTail(l);
		}

	if(fact-1)
		{
		Term t;
		t=CompoundArg1(m2);
		SetCompoundArg(t,1,NewInteger(-IntegerValue(CompoundArg1(t))));
		}		
	
	l=CompoundArgN(m2,3);
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);	
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_EPS_V)
			{
			List ll;
			ll=ListTail(l);
			while(!is_empty_list(ll))
				{
				Term t1;
				t1=ListFirst(ll);
				if(CompoundName(t1)==OPR_SPECIAL && CompoundArg1(t1)==A_EPS_V &&
					IntegerValue(ListFirst(CompoundArg2(t))) >
					IntegerValue(ListFirst(CompoundArg2(t1)))    )
					{
					List tl1,tl2;
					tl1=ConsumeCompoundArg(t,2);
					tl2=ConsumeCompoundArg(t1,2);
					SetCompoundArg(t,2,tl2);
					SetCompoundArg(t1,2,tl1);
					}
				ll=ListTail(ll);
				}
			}
		l=ListTail(l);
		}
		
	}

void color_check_spec(Atom name, List ind)
	{
	int t1, t2, t3, ito=0;
	List l;
	List itc=0;
	
	for(l=ind;l;l=ListTail(l))
	{
		int tp;
		tp=color_repres(ListFirst(l));
		if(tp)
			itc=AppendLast(itc,NewInteger(tp));
		else
			ito=1;
	}
	
	if(itc==0)
		return;
	
	if(ito)
	{
		ErrorInfo(71);
		printf("Warning: special %s breaks CompHEP color conventions.\n",
					AtomValue(name));
		return ;
	}
	
	if(ListLength(itc)!=3)
	{
		ErrorInfo(72);
		printf("Warning: special %s breaks CompHEP color conventions.\n",
					AtomValue(name));
		return ;
	}
	
	t1=IntegerValue(ListFirst(itc));
	t2=IntegerValue(ListFirst(ListTail(itc)));
	t3=IntegerValue(ListFirst(ListTail(ListTail(itc))));
	
	if(t1==1 && t2==2 && t3==3)
		{
		if(ColorLambda!=0)
			{
			printf("Warning: special %s breaks CompHEP color conventions.\n",
				AtomValue(name));
			return ;
			}
		ColorLambda=name;
		SetAtomProperty(name,A_COLOR,A_COLOR_LAMBDA);
		}
		
	if(t1==3 && t2==3 && t3==3)
		{
		if(ColorF!=0)
			{
			/*printf("Warning: special %s breaks CompHEP color conventions.\n",
				AtomValue(name));*/
			if(ColorD!=0)
			{
				printf("Warning: (color) special %s unsupported.\n",
				AtomValue(name));
				return;
			}
			ColorD=name;
			SetAtomProperty(name,A_COLOR,A_COLOR_D);			
			return ;
			}
		ColorF=name;
		SetAtomProperty(name,A_COLOR,A_COLOR_F);
		}
		
	if(t1==1 && t2==1 && t3==1)
		{
		if(ColorEps!=0)
			{
			printf("Warning: special %s breaks CompHEP color conventions.\n",
				AtomValue(name));
			return ;
			}
		ColorEps=name;
		SetAtomProperty(name,A_COLOR,A_COLOR_EPS);
		}
		
	if(t1==2 && t2==2 && t3==2)
		{
		if(ColorEpsB!=0)
			{
			printf("Warning: special %s breaks CompHEP color conventions.\n",
				AtomValue(name));
			return ;
			}
		ColorEpsB=name;
		SetAtomProperty(name,A_COLOR,A_COLOR_EPS);
		}
		
	}
