#include <stdio.h>
#include <stdlib.h>
#include "lanhep.h"

static int prop_gened = 0;

static Atom PROP_PPL;
static List plist = 0;
static List excl_prt = 0;
static int set_ppl(void), proc_param(Term), mk_hash(void);
static void print_hash(void);
static int include_ghosts = 0;
static void reg_prt(unsigned short int), unreg_prt(unsigned short int);


static Atom eprta[32];
static short int eprt[32], eprt_no, eprt_ino, eprt_wno, eprt_lno;

static int p__cmp(Term p1, Term p2)
	{
	return strcmp(AtomValue(p1),AtomValue(p2));
	}

struct tnode
	{
	unsigned short int part;
	short int prevc;
	struct tnode *prevp;
	struct tnode *curdec[10];
	};
	
	
static struct pnode 
		{
		Atom prtc;
		short int aprt;
		unsigned short int *dlist;
		}  					
		*pdlist = NULL;
		
static int pd_prtcls = 0, pd_uprtcls = 0;
unsigned short int *pdhash = NULL;
	
static struct tnode *droot;
static struct tnode *talloc(void);
static void tfree(struct tnode *);
static int r_g_d(struct tnode *);

static char rp_fit[32];
static int rp_fit_no;
static unsigned short int rp_op[35];
static unsigned short int rp_op_no;



Term ProcGenDiagr(Term t, Term ind)
	{
	int i;
	PROP_PPL=NewAtom("pprtlst",0);
	
	if(set_ppl()==0)
		return 0;
	
	if(!proc_param(t))
		return 0;
		
	if(!mk_hash())
		return 0;
		
	if(!proc_param(0))
		return 0;
	
		
	printf("%d->%d (%d arb %d loops): going to gds\n",
		eprt_ino,eprt_no-eprt_ino,eprt_wno,eprt_lno);
	
	droot=talloc();
	droot->prevp=NULL;
	droot->part=eprt[0];
	droot->prevc=-1;
	
	rp_op_no=0;
	rp_fit_no=0;
	for(i=0;i<32;i++) rp_fit[i]=0;
	
	reg_prt(eprt[0]);
	
	r_g_d(droot);
	
	tfree(droot);
	
	free(pdlist);
	free(pdhash);
	
	puts("finished");
	
	return 0;		
	
	}


static int set_ppl(void)
	{
	List l;
	if(prop_gened)
		return 1;
		
	for(l=lagr_list(); !is_empty_list(l); l=ListTail(l))
		{
		List pl,l1,l2,lr;
		
		pl=CompoundArg1(ListFirst(l));
		if(ListLength(pl)<3)
			continue;
			
		{
		Term a2;
		a2=CopyTerm(ListFirst(l)); 
		alg2_common_s(a2);
		alg2_common_n(a2);
		alg2_red_cos(a2);
		alg2_red_orth(a2);
		if(CompoundArg2(a2)==NewInteger(0) ||
		 is_empty_list(CompoundArgN(a2,5)))
		 	{
		 	FreeAtomic(a2);
		 	continue;
		 	}
		 FreeAtomic(a2);
		}

#ifdef DBG_PPL
		WriteVertex(pl); printf(": ");
#endif
		
		l1=pl;
		while(!is_empty_list(l1))
			{
			Atom pp,app;
			Term prop;
			pp=CompoundArg1(ListFirst(l1));
			if(!ListMember(plist,pp))
				plist=AppendFirst(plist,pp);
			prop=GetAtomProperty(pp,PROP_TYPE);
			if(is_compound(prop) && CompoundName(prop)==OPR_PARTICLE)
				{
				if(pp==CompoundArg1(prop))
					app=CompoundArg2(prop);
				else
					app=CompoundArg1(prop);
				}
			else
				{
				app=GetAtomProperty(pp,A_ANTI);
				if(app==0)
					{
					puts("Internal error (gd01)");
					return 0;
					}
				}
			
#ifdef DBG_PPL
			WriteTerm(app); printf(" -> ");
#endif
			
			
			lr=NewList();
			l2=pl;
			while(!is_empty_list(l2))
				{
				if(l2==l1)
					{
					l2=ListTail(l2);
					continue;
					}
				lr=AppendLast(lr,CompoundArg1(ListFirst(l2)));
				l2=ListTail(l2);
				}
			
			prop=GetAtomProperty(app,PROP_PPL);
			if(prop==0)
				SetAtomProperty(app,PROP_PPL,AppendFirst(NewList(),lr));
			else
				AppendLast(prop,lr);
#ifdef DBG_PPL
			WriteTerm(lr); printf("  ");
#endif
			while(!is_empty_list(l1) && CompoundArg1(ListFirst(l1))==pp)
				l1=ListTail(l1);
			}
#ifdef DBG_PPL
		puts("");
#endif
		}
		
	if(ListLength(plist)>1)		
		plist=SortedList(plist,p__cmp);
		
	prop_gened=1;
	return 1;
	}


static int proc_param(Term t)
	{
	int i,j;
	
	if(t==0)
		{
		
		for(i=0;i<eprt_no;i++)
			{
			short int rr;
			if(eprta[i]==0)
				{
				eprt[i]=0x3fff;
				continue;
				}
			rr=-1;
			for(j=0;j<pd_prtcls;j++)
				if(pdlist[j].prtc==eprta[i])
					rr=j;
			if(rr==-1)
				{
				printf("Error: GenDiagr: Particle '");
				WriteTerm(eprta[i]);
				puts("' not defined or does not interact with others");
				return 0;
				}
			eprt[i]=rr;
			}
			
			
		for(j=1;j<eprt_ino;j++)
			if(eprt[j]!=0x3fff)
			eprt[j]=pdlist[eprt[j]].aprt;
		
		
			
		WriteTerm(pdlist[eprt[0]].prtc);
		printf(" -> ");
		for(i=1;i<eprt_no;i++)
			{
			if(eprt[i]!=0x3fff)
				WriteTerm(pdlist[eprt[i]].prtc);
			else
				printf("*");
			printf(" ");
			}
		puts("");
		
		if(!is_empty_list(excl_prt))
			FreeAtomic(excl_prt);
			
		return 1;
		}
				
			
	include_ghosts=0;
	for(i=0;i<32;i++)
		eprta[i]=eprt[i]=0;
	eprt_no=eprt_ino=eprt_wno=eprt_lno=0;
	excl_prt=NewList();
	
	if(!is_compound(t))
		return 0;
	for(i=1;i<=CompoundArity(t);i++)
		{
		Term t1;
		t1=ConsumeCompoundArg(t,i);

		if(is_compound(t1) && CompoundName(t1)==OPR_MINUS &&
			CompoundArity(t1)==2 && is_list(CompoundArg1(t1)) &&
			is_list(CompoundArg2(t1)))
			{
			eprt_ino=ListLength(CompoundArg1(t1));
			eprt_no=eprt_ino+ListLength(CompoundArg2(t1));
			if(eprt_ino==0 || eprt_no==eprt_ino)
				{
				puts("Error: GenDiagr: epmty in- or out-state");
				return 0;
				}
			if(eprt_no<3)
				{
				puts("Error: GenDiagr: too few particles");
				return 0;
				}
			for(j=0;j<eprt_ino;j++)
				eprta[j]=ListNth(CompoundArg1(t1),j+1);
			for(j=eprt_ino;j<eprt_no;j++)
				eprta[j]=ListNth(CompoundArg2(t1),j-eprt_ino+1);
			for(j=0;j<eprt_no;j++)
				if(eprta[j]==OPR_MLT)
					{
					if(j==0)
						{
						puts("Error: GenDiagr: First particle must be defined");
						return 0;
						}
					eprta[j]=0;
					eprt_wno++;
					}
			FreeAtomic(t1);
			continue;
			}
		if(is_atom(t1) && strcmp(AtomValue(t1),"incl_ghosts")==0)
			{
			include_ghosts=1;
			continue;
			}
		if(is_compound(t1) && CompoundName(t1)==OPR_EQSIGN && 
			CompoundArity(t1)==2 && is_atom(CompoundArg1(t1)) &&
			is_integer(CompoundArg2(t1)) && 
			strcmp(AtomValue(CompoundArg1(t1)),"loops")==0)
			{
			eprt_lno=IntegerValue(CompoundArg2(t1));
			if(eprt_lno<0 || eprt_lno>10)
				{
				puts("Error: GenDiagr: this loop number not supported");
				return 0;
				}
			continue;
			}
		if(is_compound(t1) && CompoundName(t1)==OPR_EQSIGN && 
			CompoundArity(t1)==2 && is_atom(CompoundArg1(t1)) &&
			is_list(CompoundArg2(t1)) && 
			strcmp(AtomValue(CompoundArg1(t1)),"exclude")==0)
			{
			List l;
			excl_prt=ConsumeCompoundArg(t1,2);
			for(l=excl_prt;!is_empty_list(l);l=ListTail(l))
				{
				if(!is_particle(ListFirst(l),NULL))
					{
					printf("Error: GenDiagr: '");
					WriteTerm(ListFirst(l));
					puts("' is not a particle");
					return 0;
					}
				}
			continue;
			}
		printf("Error: Unknown keyword '");WriteTerm(t1);printf("' in GenDiagr\n");
		FreeAtomic(t1);
		}
		
	FreeAtomic(t);
	
	if(eprta[0]==0)
		{
		puts("Error: GenDiagr: process not specified");		
		return 0;
		}
	return 1;
	}

static int mk_hash(void)
	{
	int i, j, p, up, p1, p11;
	List l,l1;
	unsigned short int *php;
	Term prop;
	p=up=p1=p11=0;
	
	for(l=plist;!is_empty_list(l);l=ListTail(l))
		{
		prop=GetAtomProperty(ListFirst(l),PROP_TYPE);
		if(is_compound(prop) && CompoundName(prop)==OPR_FIELD)
			{
			int ft;
			ft=IntegerValue(CompoundArg2(prop));
			if(ft==1 || ft==2 || ft==3)
				{
				up++;
				continue;
				}
			}
		p++;
		
		prop=GetAtomProperty(ListFirst(l),PROP_PPL);
		if(prop==0)
			{
			puts("Internal error (gd02)");
			return 0;
			}
			
		for(l1=prop;!is_empty_list(l1);l1=ListTail(l1))
			{
			List l2;
			int gi;
			
			if(!include_ghosts)
				{
				gi=0;
				for(l2=ListFirst(l1);!is_empty_list(l2);l2=ListTail(l2))
					{
					Term prop;
					prop=GetAtomProperty(ListFirst(l2),PROP_TYPE);
					if(is_compound(prop) && CompoundName(prop)==OPR_FIELD)
						{
						int ft;
						ft=IntegerValue(CompoundArg2(prop));
						if(ft==1 || ft==2 || ft==3)
							gi=1;
						}
					}
				if(gi==1)
					continue;
				}
			
			if(!is_empty_list(excl_prt))
				{	
				gi=0;			
				for(l2=ListFirst(l1);!is_empty_list(l2);l2=ListTail(l2))
					if(ListMember(excl_prt,ListFirst(l2)))
						gi=1;
				if(gi)
					continue;	
				}
					
			p1++;
			p11+=ListLength(ListFirst(l1));
	
			}
		}
		
	
	printf("mkhash: %d prtcls (%d unph), %d decmod, %d leaves\n",
			p,up,p1,p11);
			
	pd_prtcls=p;
	pd_uprtcls=up;
	
	pdlist=malloc(sizeof(struct pnode)*(p+up));
	if(pdlist==NULL)
		{
		puts("No memory for pdecay table");
		return 0;
		}
		
	for(i=0;i<p+up;i++)
		pdlist[i].dlist=NULL;
	
	pdhash=malloc(sizeof(unsigned short int)*p11);
	if(pdhash==NULL)
		{
		puts("No memory for pdecay hash");
		return 0;
		}
		
	php=pdhash;


	
	/******     Atom -> number *******/
	
	i=j=0;
	
	for(l=plist;!is_empty_list(l);l=ListTail(l))
		{
		prop=GetAtomProperty(ListFirst(l),PROP_TYPE);
		if(is_compound(prop) && CompoundName(prop)==OPR_FIELD)
			{
			int ft;
			ft=IntegerValue(CompoundArg2(prop));
			if(ft==1 || ft==2 || ft==3)
				{
				pdlist[j+p].prtc=ListFirst(l);
				j++;
				continue;
				}
			}
		
		prop=GetAtomProperty(ListFirst(l),PROP_PPL);
		if(prop==0)
			{
			puts("Internal error (gd03)");
			return 0;
			}
			
		pdlist[i].prtc=ListFirst(l);
		i++;
		}
		
	if(i!=p || j!=up)
		{
		puts("Internal error (gd04)");
		return 0;
		}
		
		
	
	
	/**************    Gen antiprt no   ***********/
	
	i=0;
	
	for(i=0;i<p+up;i++)
		{
		Atom aa,aan;
		prop=GetAtomProperty(pdlist[i].prtc,A_ANTI);
		if(prop)
			aa=prop;
		else
			{
			prop=GetAtomProperty(pdlist[i].prtc,PROP_TYPE);
			if(!is_compound(prop) || CompoundName(prop)!=OPR_PARTICLE)
				{
				puts("Internal error (gd05)");
				return 0;
				}
			if(pdlist[i].prtc==CompoundArg1(prop))
				aa=CompoundArg2(prop);
			else
				aa=CompoundArg1(prop);
			}
			
		aan=-1;
		for(j=0;j<p+up;j++)
			if(pdlist[j].prtc==aa)
				{
				aan=j;
				break;
				}
				
		if(j==p+up)
			{
			puts("Internal error (gd06)");
			WriteTerm(aa);
			puts("");
			for(j=0;j<p+up;j++)
				WriteTerm(pdlist[j].prtc),printf(" ");
			puts("");
			return 0;
			}
		
		pdlist[i].aprt=aan;
		}
		
	/************ Set decay list **************/
	
	for(i=0;i<p;i++)
		{
		Term prop;
		
		prop=GetAtomProperty(pdlist[i].prtc,PROP_PPL);
		
		if(prop==0)
			{
			puts("Internal error (gd07)");
			return 0;
			}
		
		for(l1=prop;!is_empty_list(l1);l1=ListTail(l1))
			{
			List l2;
			int gi;
			
			if(!include_ghosts)
				{
				gi=0;
				for(l2=ListFirst(l1);!is_empty_list(l2);l2=ListTail(l2))
					{
					Term prop;
					prop=GetAtomProperty(ListFirst(l2),PROP_TYPE);
					if(is_compound(prop) && CompoundName(prop)==OPR_FIELD)
						{
						int ft;
						ft=IntegerValue(CompoundArg2(prop));
						if(ft==1 || ft==2 || ft==3)
							gi=1;
						}
					}
				if(gi==1)
					continue;
				}
				
			if(!is_empty_list(excl_prt))
				{	
				gi=0;			
				for(l2=ListFirst(l1);!is_empty_list(l2);l2=ListTail(l2))
					if(ListMember(excl_prt,ListFirst(l2)))
						gi=1;
				if(gi)
					continue;	
				}
			
			if(pdlist[i].dlist==NULL)
				pdlist[i].dlist=php;
				
			for(l2=ListFirst(l1);!is_empty_list(l2);l2=ListTail(l2))
				{
				Atom a;
				int an;
				a=ListFirst(l2);
				an=-1;
				for(j=0;j<p+up;j++)
					if(pdlist[j].prtc==a)
						{
						an=j;
						break;
						}
				if(an==-1)
					{
					puts("Internal error (gd08)");
					return 0;
					}
				*php=an;
				php++;
				}	
			*(php-1)|=0x4000;				
			}
		*(php-1)|=0x8000;
		}	
	
	
	print_hash();
		
	return 1;

	}
		


static void print_hash(void)
	{
	int i;
	unsigned short int *pp, pn;
	for(i=0;i<pd_prtcls+pd_uprtcls;i++)
		{
		printf("%4s (a=%4s) -> (",	AtomValue(pdlist[i].prtc),
								AtomValue(pdlist[pdlist[i].aprt].prtc));
		if(pdlist[i].dlist==NULL)
			{
			puts("NULL)");
			continue;
			}
			
		pp=pdlist[i].dlist; 
		pp--; 
		do	{
			pp++;
			pn=((*pp)&0x3fff);
			printf(" %4s ",AtomValue(pdlist[pn].prtc));
			if((*pp/0x4000)==1)
				printf(") (");
			if((*pp/0x4000)==3)
				{
				puts(")");
				break;
				}
			}	while(1);
			
		}
		
	}	

static struct tnode *tbuffers[25];
static int t_blocks = 0, t_alloc=0, t_free=0;
static struct tnode *t_next_free = NULL;

static void tfree(struct tnode *p)
	{
	p->prevp=t_next_free;
	t_next_free=p;
	t_free++;
	}
	
static struct tnode *talloc(void)
	{
	struct tnode *p;
	if(t_next_free==NULL)
		{
		int i;
		if(t_blocks==25)
			{  puts("Internal error (too much tnodes or lack space)."); exit(0); }
		p=tbuffers[t_blocks]=(struct tnode*)malloc(sizeof(struct tnode)*100);
		if(p==NULL)
			{  puts("Internal error (lack space for tnodes)."); exit(0); }
		for(i=0;i<100;i++)
			{
			p[i].prevp=t_next_free;
			t_next_free=p+i;
			}
		t_blocks++;
		}
	p=t_next_free;
	t_next_free=p->prevp;
	t_alloc++;
	p->prevp=NULL;
	p->prevc=-1;
	p->curdec[0]=NULL;
	return p;
	}


static void reg_prt(unsigned short int pp)
	{
	int i;
	rp_op[rp_op_no]=pp;
	rp_op_no++;
	for(i=1;i<eprt_no;i++)
		{
		if(rp_fit[i]==0 && pp==eprt[i])
			{
			rp_fit[i]=1;
			rp_fit_no++;
			return;
			}
		}
	}
	
static void unreg_prt(unsigned short int pp)
	{
	int i,j,n1,n2;
	for(i=rp_op_no-1;i>=0;i--)
		if(rp_op[i]==pp)
			{
			for(j=i;j<rp_op_no-1;j++)
				rp_op[j]=rp_op[j+1];
			break;
			}
	rp_op_no--;
	if(i==-1)
		{
		puts("Internal error (gd09)");
		return;
		}
	
	n1=n2=0;
	for(i=1;i<eprt_no;i++)
		if(eprt[i]==pp) n1++;
	for(i=0;i<rp_op_no;i++)
		if(rp_op[i]==pp) n2++;
	if(n2<n1)
		{
		for(i=1;i<eprt_no;i++)
			if(eprt[i]==pp && rp_fit[i]==1)
				{
				rp_fit[i]=0;
				rp_fit_no--;
				break;
				}
		if(i==eprt_no)
			{
			puts("Internal error (gd10)");
			return;
			}
		}
	}
	
static struct tnode *next_node(struct tnode *pp)
	{
	int cn;
	
	while(pp->prevp!=NULL && pp->prevp->curdec[pp->prevc+1]==NULL)
		{
		cn=pp->prevc;
		pp=pp->prevp;
		}
	if(pp->prevp==NULL)
		return NULL;
	
	cn=pp->prevc;
	pp=pp->prevp;
	cn++;
	pp=pp->curdec[cn];
	while(pp->curdec[0]!=NULL)
		pp=pp->curdec[0];
	return pp;
	
	}

static int r_g_d(struct tnode *ct)
	{
	
	reg_prt(3);
	printf("%d\n",rp_fit_no);	
	reg_prt(3);
	printf("%d\n",rp_fit_no);	
	reg_prt(3);
	printf("%d\n",rp_fit_no);	
	unreg_prt(3);
	printf("%d\n",rp_fit_no);	
	unreg_prt(3);
	printf("%d\n",rp_fit_no);	
	unreg_prt(3);
	printf("%d\n",rp_fit_no);	
	
	
	
	return 1;
	}
